(defun c:tl (/ ss tl n ent itm obj l)
  (setq	ss (ssget)
	tl 0
	n  (1- (sslength ss))
  )
  (while (>= n 0)
    (setq ent (entget (setq itm (ssname ss n)))
	  obj (cdr (assoc 0 ent))
	  l   (cond
		((= obj "line")
		 (distance (cdr (assoc 10 ent)) (cdr (assoc 11 ent)))
		)
		((= obj "arc")
		 (* (cdr (assoc 40 ent))
		    (if	(minusp	(setq l	(- (cdr (assoc 51 ent))
					   (cdr (assoc 50 ent))
					)
				)
			)
		      (+ pi pi l)
		      l
		    )
		 )
		)
		((or (= obj "circle")
		     (= obj "spline")
		     (= obj "polyline")
		     (= obj "lwpolyline")
		     (= obj "ellipse")
		 )
		 (vl-cmdf "_.area" "_o" itm)
		 (getvar "perimeter")
		)
		(t 0)
	      )
	  tl  (+ tl l)
	  n   (1- n)
    )
  )
  (alert (strcat "la longueur total est " (rtos tl)))
  (princ)
)
