;; ADDFIELDS (gile)
;; Insre un texte contenant un champ dynamique dont la valeur
;; est gale  la somme des valeurs des champs slectionns
;;
;; NOTA : aucun contrle sur la validit des champs slectionns

(defun c:AddFields (/ ss res code pos ins)
  (vl-load-com)
  (or *acdoc*
      (setq *acdoc* (vla-get-ActiveSelectionSet (vlax-get-acad-object)))
  )
  (if (ssget '((0 . "MTEXT,TEXT")))
    (progn
      (setq res "%<\\AcExpr ")
      (vlax-for txt (setq ss (vla-get-ActiveSelectionSet *acdoc*))
        (if (and
              (setq code (vla-FieldCode txt))
              (setq pos (vl-string-search "%<" code))
              (setq code (substr code (1+ pos)))
              (setq pos (vl-string-position 37 code 1 T))
              (setq code (substr code 1 (1+ pos)))
            )
          (setq res (strcat res code " + "))
        )
      )
      (vla-delete ss)
      (setq res (strcat (vl-string-right-trim " +" res)
                        " "
                        (if (setq pos (vl-string-position (ascii "\\") code 1 T))
                          (substr code (1+ pos))
                          ">%"
                        )
                )
      )
      (if (and res
               (setq ins (getpoint "\nPoint d'insertion: "))
          )
        (vla-addText
          (if (= 1 (getvar 'cvport))
            (vla-get-PaperSpace *acdoc*)
            (vla-get-ModelSpace *acdoc*)
          )
          res
          (vlax-3d-point (trans ins 1 0))
          (getvar 'textsize)
        )
      )
    )
  )
  (princ)
)
