;;; *****************************************************************
;;;
;;; Export de toutes les prsentation et cration d'un DWG
;;;
;;;           Christian REB pour SPIE, le 9 Octobre 2013
;;;
;;; *****************************************************************

;;; ---------------------------
;;; Fonction principale
;;; ---------------------------

(defun c:LayoutToDWG()

	(setq	LAYLST	(layoutlist)
		INDICE	"---Layout_Exp---"
		TOTFIC	0
	);setq

	(foreach	NOMLAYOUT	LAYLST

		(exportlayout)

	);foreach

	(command "_-layout" "E" "model")

	(prompt "\nTraitement termin ! ") (princ TOTFIC) (prompt " fichiers crs...")
(princ)
);defun

;;; ---------------------------
;;; Fonction export LAYOUT
;;; ---------------------------

(defun	exportlayout()

	(command "_-layout" "E" NOMLAYOUT)
	(command "_pspace" "_zoom" "_E" "_mspace")


	(setq	NOMFIC	(strcat (substr (getvar "dwgname") 1 (- (strlen (getvar "dwgname") ) 4) )
				"---"
				NOMLAYOUT
				INDICE
			);strcat

			TOTFIC	(+ TOTFIC 1)
	);setq 

	(command "_EXPORTLAYOUT" NOMFIC )
	(prompt "\nNom du fichier cr ---> ") (prompt NOMFIC)

);defun

;;; ------------------------ FIN PROG --------------------------------	

(prompt "\nTaper   LayoutToDWG   pour crer un dessin  partir de chaque Prsentation...")
(princ)
